SystemOrganization addCategory: #'Kernel-ClassBuilderTests'!

TestCase subclass: #LayoutTest
	instanceVariableNames: 'layout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilderTests'!

LayoutTest subclass: #BitsLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilderTests'!

!BitsLayoutTest class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/19/2011 23:37'!
isAbstract
	^ self = BitsLayoutTest! !

!BitsLayoutTest methodsFor: 'as yet unclassified' stamp: 'CAmi 3/18/2011 13:03'!
layoutClass
	^ BitsLayout! !

!BitsLayoutTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/19/2011 23:34'!
testFixedSize
	self assert: layout fixedSize = 0! !

BitsLayoutTest subclass: #ByteLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilderTests'!

!ByteLayoutTest methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 17:05'!
layoutClass
	^ ByteLayout! !

BitsLayoutTest subclass: #WordLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilderTests'!

!WordLayoutTest methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 17:05'!
layoutClass
	^ WordLayout! !

!LayoutTest class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/19/2011 23:37'!
isAbstract
	^ self = LayoutTest! !

!LayoutTest class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/19/2011 23:36'!
shouldInheritSelectors
	^ true! !

!LayoutTest methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 17:03'!
layoutClass
	^ Layout! !

!LayoutTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:19'!
newLayoutInstance
	^ self layoutClass new! !

!LayoutTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:19'!
setUp
	super setUp.
	layout := self newLayoutInstance.! !

LayoutTest subclass: #LayoutWithSlotsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilderTests'!

!LayoutWithSlotsTest class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/19/2011 23:37'!
isAbstract
	^ self = LayoutWithSlotsTest! !

!LayoutWithSlotsTest methodsFor: 'as yet unclassified' stamp: 'CAmi 3/18/2011 13:02'!
layoutClass
	^ LayoutWithSlots! !

!LayoutWithSlotsTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:21'!
newLayoutInstance
	|instance|
	instance := self layoutClass new: 1.
	instance at: 1 put: (Slot named: #field1).
	^ instance! !

!LayoutWithSlotsTest methodsFor: 'as yet unclassified' stamp: 'CAmi 3/18/2011 13:04'!
testAtName
	layout := self layoutClass new: 3.
	layout at: 1 put: #a asSlot.
	layout at: 2 put: #b asSlot.
	layout at: 3 put: #c asSlot.
	
	self assert: (layout atName: #a) == (layout at: 1).
	self assert: (layout atName: #b) == (layout at: 2).
	self assert: (layout atName: #c) == (layout at: 3).	! !

!LayoutWithSlotsTest methodsFor: 'as yet unclassified' stamp: 'CAmi 3/18/2011 13:05'!
testAtNameIfAbsent
	layout := self layoutClass new: 2.
	layout at: 1 put: #a asSlot.
	layout at: 2 put: #b asSlot.
	
	self assert: (layout atName: #a ifAbsent: [ #none ]) == (layout at: 1).
	self assert: (layout atName: #b ifAbsent: [ #none ] ) == (layout at: 2).
	
	self assert: (layout atName: #c ifAbsent: [ #none ]) == #none.
	self assert: (layout atName: #d ifAbsent: [ #none ] ) == #none.! !

!LayoutWithSlotsTest methodsFor: 'as yet unclassified' stamp: 'CAmi 3/18/2011 13:04'!
testAtPut
	| slotA slotC slotB |
	
	layout := self layoutClass new: 3.
	
	slotA := layout at: 1 put: #a asSlot.
	self assert: slotA index = 1.
	self assert: (layout at: 1) == slotA.
	
	slotB := layout at: 2 put: #b asSlot.
	self assert: slotB index = 2.
	self assert: (layout at: 2) == slotB.
	
	slotC := layout at: 3 put: #c asSlot.
	self assert: slotC index = 3.
	self assert: (layout at: 3) == slotC.! !

!LayoutWithSlotsTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:21'!
testFixedSize
	self assert: layout fixedSize = 1.
	
	layout := self layoutClass new: 2.
	layout at: 1 put: (Slot named: #field1).
	layout at: 2 put: (Slot named: #slot2).
	
	self assert: layout fixedSize = 2.! !

!LayoutWithSlotsTest methodsFor: 'as yet unclassified' stamp: 'CAmi 3/18/2011 13:04'!
testIncludesName
	layout := self layoutClass new: 2.
	layout at: 1 put: #a asSlot.
	layout at: 2 put: #b asSlot.
	
	self assert: (layout includesName: #a).
	self assert: (layout includesName: #b).
	self deny: (layout includesName: #c).
	self deny: (layout includesName: #d).! !

!LayoutWithSlotsTest methodsFor: 'as yet unclassified' stamp: 'MartinDias 6/13/2012 00:25'!
testSlotIndexes
	|slot1 slot2|
	slot1 := #field1 => Slot.
	slot2 := #field2 => Slot.
	
	layout := self layoutClass new: 2.
	layout at: 1 put: slot1.
	layout at: 2 put: slot2.
	
	layout finalize.
	
	self assert: slot1 index = 1.
	self assert: slot2 index = 2.! !

LayoutWithSlotsTest subclass: #ObjectLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilderTests'!

!ObjectLayoutTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/30/2011 19:21'!
layoutClass
	^ PointerLayout! !

LayoutWithSlotsTest subclass: #VariableLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilderTests'!

!VariableLayoutTest methodsFor: 'as yet unclassified' stamp: 'CAmi 3/15/2011 17:05'!
layoutClass
	^ VariableLayout! !

TestCase subclass: #SlotTest
	instanceVariableNames: 'slotObject layout slotObjectClass slot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilderTests'!

!SlotTest class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 17:05'!
shouldInheritSelectors
	^ true! !

!SlotTest methodsFor: 'converting' stamp: 'CamilloBruni 3/10/2011 16:32'!
assertSlotAt: index named: name
	self assert: (layout at: index) name = name.! !

!SlotTest methodsFor: 'running' stamp: 'CamilloBruni 3/20/2011 16:21'!
newSlotInstance
	^ self slotClass named: #field1.! !

!SlotTest methodsFor: 'running' stamp: 'CamilloBruni 3/20/2011 15:56'!
newTestObjectInstance
	^ self slotTestObjectClass new.! !

!SlotTest methodsFor: 'running' stamp: 'CamilloBruni 3/30/2011 14:31'!
prepareTestObjectClass
	slotObjectClass initialize.
	slotObjectClass layout at: 1 put: slot.
	! !

!SlotTest methodsFor: 'running' stamp: 'CamilloBruni 3/31/2011 14:37'!
setUp
	slotObjectClass := self slotTestObjectClass.
	slot := self newSlotInstance.
	self prepareTestObjectClass.
	slotObject := self newTestObjectInstance.
	layout := slotObjectClass layout.! !

!SlotTest methodsFor: 'accessing' stamp: 'CamilloBruni 3/20/2011 16:25'!
slot
	^ self slot1! !

!SlotTest methodsFor: 'accessing' stamp: 'CamilloBruni 3/20/2011 16:26'!
slot1
	^  layout at: 1! !

!SlotTest methodsFor: 'accessing' stamp: 'CamilloBruni 3/20/2011 16:26'!
slot2
	^  layout at: 2! !

!SlotTest methodsFor: 'accessing' stamp: 'CamilloBruni 3/20/2011 16:26'!
slot3
	^  layout at: 3! !

!SlotTest methodsFor: 'accessing' stamp: 'CamilloBruni 3/20/2011 15:44'!
slotClass
	^ Slot! !

!SlotTest methodsFor: 'tests' stamp: 'CamilloBruni 3/20/2011 15:56'!
slotTestObjectClass
	^ SlotTestObject! !

!SlotTest methodsFor: 'running' stamp: 'CamilloBruni 3/25/2011 13:36'!
tearDown
	slotObjectClass resetLayout! !

!SlotTest methodsFor: 'tests' stamp: 'CamilloBruni 3/20/2011 16:25'!
testIndex
	self assert: self slot index = 1.! !

!SlotTest methodsFor: 'tests' stamp: 'CamilloBruni 3/20/2011 16:21'!
testLayout
	self assertSlotAt: 1 named: #field1.! !

!SlotTest methodsFor: 'tests' stamp: 'CamilloBruni 3/20/2011 15:39'!
testSize
	self assert: self slot size = 1.! !

Object subclass: #SlotTestObject
	instanceVariableNames: 'field1 field2 field3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilderTests'!

!SlotTestObject class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/25/2011 13:36'!
resetLayout
	self layout at: 1 put: (#field1 => Slot).
	self layout at: 2 put: (#field2 => Slot).
	self layout at: 3 put: (#field3 => Slot).! !

!SlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:24'!
field1
	^ field1! !

!SlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:24'!
field1: aValue
	field1 := aValue! !

!SlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:24'!
field2
	^ field2! !

!SlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:24'!
field2: aValue
	field2 := aValue! !

!SlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:24'!
field3
	^ field3! !

!SlotTestObject methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/20/2011 16:24'!
field3: aValue
	field3 := aValue! !
